.386
.model flat, stdcall
option casemap: none

   include         /masm32/include/windows.inc
   include         /masm32/include/kernel32.inc
   include         /masm32/include/user32.inc
   include         /masm32/include/comctl32.inc
   include         /masm32/include/masm32.inc
   include         /masm32/include/debug.inc
   include         /masm32/include/Setupapi.inc
   
   includelib      /masm32/lib/kernel32.lib
   includelib      /masm32/lib/user32.lib
   includelib      /masm32/lib/comctl32.lib
   includelib      /masm32/lib/masm32.lib
   includelib      /masm32/lib/debug.lib
   includelib      /masm32/lib/Setupapi.lib

SP_DEVINFO_DATA STRUCT
     cbSize              dd ?
     ClassGuid           GUID <>
     DevInst             dd ?
     Reserved            dd ?
SP_DEVINFO_DATA ENDS

.const
     DIGCF_PRESENT           equ 02h
     DIGCF_DEVICEINTERFACE   equ 10h
     SPDRP_FRIENDLYNAME      equ 0000000Ch
     SPDRP_REMOVAL_POLICY    equ 0000001Fh
     GUID_DEVINTERFACE_DISK	 TEXTEQU <{053f56307h,0b6bfh,011d0h,{094h,0f2h,000h,0a0h,0c9h,01eh,0fbh,08bh}}>
     xGUID_DEVINTERFACE_DISK GUID GUID_DEVINTERFACE_DISK

.data
  txtShutdown         db "Shutting down",0
  
.data?
  hDrive              HANDLE ?
  hDeviceInfoSet      HANDLE ?
  cbReturned          dd ?
  hDeviceInstance     dd ?
  szVetoName          dd ? 
  szRemovable         db 256 dup (?)
  szBuff1             db 128 dup (?)
  devinfo             SP_DEVINFO_DATA  <?>


.code
 start:

    invoke SetupDiGetClassDevs,addr xGUID_DEVINTERFACE_DISK,0,0,DIGCF_PRESENT + DIGCF_DEVICEINTERFACE
    mov hDeviceInfoSet,eax
     
    xor ecx,ecx
    mov devinfo.cbSize,sizeof SP_DEVINFO_DATA
@@:
    push ecx
    invoke SetupDiEnumDeviceInfo,hDeviceInfoSet,ecx,addr devinfo
        .if eax == TRUE
            invoke SetupDiGetDeviceRegistryProperty,hDeviceInfoSet,addr devinfo,SPDRP_REMOVAL_POLICY,NULL,addr szRemovable,4,0
                .if szRemovable == 3 ; if its removable get device friendly name
                    invoke SetupDiGetDeviceRegistryProperty,hDeviceInfoSet,addr devinfo,SPDRP_FRIENDLYNAME,NULL,addr szRemovable,256,0
                    invoke CM_Get_Parent,addr hDeviceInstance,devinfo.DevInst,0
                    invoke CM_Request_Device_Eject,hDeviceInstance,0,addr szVetoName,MAX_PATH,0                  
                    invoke MessageBox,0,addr szRemovable,addr txtShutdown,0
                    invoke RtlZeroMemory,addr szRemovable,sizeof szRemovable
                    pop ecx
                    inc ecx
                    jmp @B
                .else ; its not removable
                    pop ecx
                    inc ecx
                    jmp @B
                .endif
         .endif

invoke SetupDiDestroyDeviceInfoList,hDeviceInfoSet
invoke CloseHandle,hDrive
					

; #################################################################################################

end start